package com.tofly.third.common.util;

import com.tofly.third.config.JwtConfig;
import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwts;
import io.jsonwebtoken.SignatureAlgorithm;
import io.jsonwebtoken.SignatureException;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;

/**
 * Author  Administrator
 *
 * @Date 2025-12-03 17:25 （创建时间）
 * @Version 1.0 （版本号）
 */
public class TokenUtil {

    @Autowired
    private static  JwtConfig jwtConfig;
    private static final String SECRET_KEY = "tofly@028"; // 确保这个密钥足够安全且保密
    private static final long EXPIRATION_TIME = 180000; // 1小时过期时间，单位为毫秒

    public static String generateToken(String username,String role) {
        return Jwts.builder()
                .setSubject(username)
                .setIssuedAt(new Date())
                .setExpiration(new Date(System.currentTimeMillis() + EXPIRATION_TIME))
                .signWith(SignatureAlgorithm.HS512, SECRET_KEY)
                .compact();
    }


    public static boolean validateToken(String token) {
        try {
            Claims claims = Jwts.parser()
                    .setSigningKey(SECRET_KEY)
                    .parseClaimsJws(token)
                    .getBody();
            return true; // 如果未抛出异常，则表示token有效
        } catch (SignatureException ex) {
            // 签名无效，可能被篡改
            System.out.println("Invalid signature");
        } catch (Exception ex) {
            // 其他错误，例如token已过期或格式不正确等
            System.out.println("Token is not valid");
        }
        return false; // 如果抛出异常，则返回false表示token无效或存在问题
    }

}
